{% extends "./index.html" %}
{% load static %}
{% block contenido %}
    <div class="container">
        <h1 class="text-center blanco-text">Listado de Recetas</h1>
        <div class="row justify-content-center">
            <div class="col-md-6">
                <form class="mb-4" action="/guardarReceta/" method="post" enctype="multipart/form-data" id="frm_nuevo_receta">
                    {% csrf_token %}
                    <div class="mb-3">
                        <label for="id_pla" class="form-label blanco-text">Platillo:</label>
                        <select class="form-control" name="id_pla" id="id_pla" required>
                            <option value="">--Seleccione el Platillo--</option>
                            {% for platillo in platillos %}
                                <option value="{{platillo.id_bf}}">{{platillo.nombre_bf}}</option>
                            {% endfor %}
                        </select>
                    </div>
                    <div class="mb-3">
                        <label for="id_ing" class="form-label blanco-text">Ingrediente:</label>
                        <select class="form-control" name="id_ing" id="id_ing" required>
                            <option value="">--Seleccione el Ingrediente--</option>
                            {% for ingrediente in ingredientes %}
                                <option value="{{ingrediente.id_bf}}">{{ingrediente.nombre_bf}}</option>
                            {% endfor %}
                        </select>
                    </div>
                    <div class="mb-3">
                        <label for="cantidad_necesaria_bf" class="form-label blanco-text">Cantidad Necesaria en Gramos:</label>
                        <input type="text" name="cantidad_necesaria_bf" id="cantidad_necesaria_bf" class="form-control" placeholder="Ingrese la Cantidad" step="0.01" required>
                    </div>
                    <div class="mb-3">
                        <label for="tiempo_prepraracion_bf" class="form-label blanco-text">Tiempo de Preparación:</label>
                        <input type="text" name="tiempo_prepraracion_bf" id="tiempo_prepraracion_bf" class="form-control" placeholder="Ingrese el Tiempo de Preparación" required>
                    </div>
                    <div class="mb-3">
                        <label for="instrucciones_bf" class="form-label blanco-text">Instrucciones:</label>
                        <textarea name="instrucciones_bf" id="instrucciones_bf" cols="3" class="form-control" placeholder="Ingrese las Instrucciones" required></textarea>
                    </div>
                    <div class="mb-3">
                        <label for="comentario_bf" class="form-label blanco-text">Comentario:</label>
                        <textarea name="comentario_bf" id="comentario_bf" cols="3" class="form-control" placeholder="Ingrese comentarios o sugerencias"></textarea>
                    </div>
                    <div class="mb-3">
                        <label for="bafa_nombre_pais" class="form-label blanco-text">Ingrese el nombre del Pais:</label>
                        <input type="text" name="bafa_nombre_pais" id="bafa_nombre_pais" class="form-control" placeholder="Ingrese el Nombre del Pais" required>
                    </div>
                    <div class="mb-3">
                        <label for="bafa_patente" class="form-label blanco-text">Fotografia:</label>
                        <br>
                        <input type="file" id="bafa_patente" name="bafa_patente" accept="image/*" placeholder="Ingrese la imagen patente" value="">
                    </div>
                    <div class="text-center">
                        <button type="submit" name="button" class="btn btn-primary">Guardar</button>
                        <button type="reset" name="button" class="btn btn-danger">Cancelar</button>
                    </div>
                </form>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <h1 class="text-center blanco-text">LISTADO DE RECETAS</h1>
                <table class="table" id="tbl_receta">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>CANTIDAD NECESARIA</th>
                            <th>TIEMPO DE PREPARACIÓN</th>
                            <th>INSTRUCCIONES</th>
                            <th>COMENTARIO</th>
                            <th>PLATILLO</th>
                            <th>INGREDIENTE</th>
                            <th>NOMBRE DEL PAIS</th>
                            <th>PATENTE</th>
                            <th>ACCIONES</th>
                        </tr>
                    </thead>
                    <TBody>
                        {% for receta in recetas %}
                            <tr>
                                <td>{{receta.id_bf}}</td>
                                <td>{{receta.cantidad_necesaria_bf}}</td>
                                <td>{{receta.tiempo_prepraracion_bf}}</td>
                                <td>{{receta.instrucciones_bf}}</td>
                                <td>{{receta.comentario_bf}}</td>
                                <td>{{receta.platillo.nombre_bf}}</td>
                                <td>{{receta.ingrediente.nombre_bf}}</td>
                                <td>{{receta.bafa_nombre_pais}}</td>
                                <td>
                                  {% if receta.bafa_patente %}
                                  <a href="{{ receta.bafa_patente.url }}" target="_blank"><img src="{{ receta.bafa_patente.url }}" alt="" height="80px"></a>
                                  {% else %}
                                  <b>N/A</b>
                                  {% endif %}
                                </td>
                                <td>
                                    <a href="/editarReceta/{{receta.id_bf}}" class="btn btn-warning">Editar</a>
                                    <a href="javascript:void(0)" class="btn btn-danger" onclick="eliminarReceta('/eliminarReceta/{{receta.id_bf}}');">Borrar</a>
                                </td>
                            </tr>
                        {% endfor %}
                    </TBody>
                </table>
            </div>
        </div>
    </div>

    <script type="text/javascript">
        function eliminarReceta(url){
            iziToast.question({
                timeout: 15000,
                close: true,
                overlay: true,
                displayMode: 'once',
                id: 'question',
                zindex: 999,
                title: 'CONFIRMACIÓN',
                message: '¿Está seguro de eliminar la receta seleccionada?',
                position: 'center',
                buttons: [
                    ['<button><b>SI</b></button>', function (instance, toast) {
                        instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                        window.location.href=url;
                    }, true],
                    ['<button>NO</button>', function (instance, toast) {
                        instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                    }],
                ]
            });
        }
    </script>

    <script type="text/javascript">
        $("#frm_nuevo_receta").validate({
            rules:{
                "id_pla":{
                    required:true
                },
                "id_ing":{
                    required:true
                },
                "cantidad_necesaria_bf":{
                    required:true,
                    number:true
                },
                "tiempo_prepraracion_bf":{
                    required:true
                },
                "instrucciones_bf":{
                    required:true
                },
                "comentario_bf":{
                    required:true
                },
                "bafa_nombre_pais":{
                    required:true,
                    soloLetras: true
                },
                "bafa_patente":{
                    required:true
                }
            },
            messages:{
                "id_pla":{
                    required:"Por favor seleccione un Platillo"
                },
                "id_ing":{
                    required:"Por favor seleccione un Ingrediente"
                },
                "cantidad_necesaria_bf":{
                    required:"Por favor ingrese una Cantidad",
                    number:"Ingrese solo números"
                },
                "tiempo_prepraracion_bf":{
                    required:"Por favor ingrese   un Tiempo de Preparación"
                },
                "instrucciones_bf":{
                    required:"Por favor ingrese instrucciones"
                },
                "comentario_bf":{
                    required:"Debe ingresar un comentario"
                },
                "bafa_nombre_pais":{
                    required:"Debe ingresar un nombre del pais",
                    soloLetras: "Solo se permiten letras en este campo"
                }
            }
        });
    </script>


    <script type="text/javascript">
        $(document).ready(function() {
            // Agrega el método de validación personalizado
            $.validator.addMethod("soloLetras", function(value, element) {
                return /^[a-zA-Z\s]+$/.test(value);
            }, "Solo se permiten letras en este campo");

            // Inicializa el DataTable
            $('#tbl_receta').DataTable({
                dom: 'Bfrtip',
                language: {
                    url: '//cdn.datatables.net/plug-ins/1.13.7/i18n/es-ES.json',
                },
                buttons: [
                    {
                        extend: 'pdfHtml5',
                        text: '<i class="fa fa-file-pdf-o"></i> PDF',
                        titleAttr: 'Exportar a PDF',
                        className: 'btn btn-danger', // Clase de estilo para el botón
                        title: 'LISTADO RECETAS'
                    },
                    {
                        extend: 'print',
                        text: '<i class="fa fa-print"></i> Imprimir',
                        titleAttr: 'Imprimir',
                        className: 'btn btn-primary' // Clase de estilo para el botón
                    },
                    {
                        extend: 'csv',
                        text: '<i class="fa fa-file-text-o"></i> CSV',
                        titleAttr: 'Exportar a CSV',
                        className: 'btn btn-success' // Clase de estilo para el botón
                    }
                ]
            });

            // Inicializa la validación del formulario
            $("#tu_formulario").validate({
                rules: {
                    "bafa_nombre_pais": {
                        required: true,
                        soloLetras: true  // Agrega la regla personalizada
                    }
                    // Agrega otras reglas de validación según sea necesario
                },
                messages: {
                    "bafa_nombre_pais": {
                        required: "Por favor, ingrese el nombre del país",
                        soloLetras: "Solo se permiten letras en este campo"
                    }
                    // Agrega mensajes de error personalizados para otras reglas si es necesario
                }
            });
        });
    </script>

{% endblock %}
